#include <stdio.h>
#include <string.h>
#include <Rabbit2000.h>
#include "rabbitlwip.h"
#include "httpd.h"


far void main(void)
{
    // Dummy configuration, will be overwritten by DHCP
    NetConfig config;
    NetConnectionConfig interface;
    struct netif * network;
    char MACString[20];
    int productID;

    WDT_DISABLE();

    // Clear the Softools WinIDE print buffer from any previous program runs
    printf("\x1A");
    productID = netRecognize();
    config.hostName = "test";
    config.domainName = "toman.org";
    netStringToIP("192.168.10.1", &config.defaultGateway);
    netConfigure(&config);

    // Start ethernet with DHCP using default handlers (will respond to
    // ICMP echo requests)
    printf("** Starting Ethernet Interface **\n");
    printf("Rabbit 2000/3000 board or core module %s recognized\n",
           (productID ? "is" : "is not"));

    interface.connType = ETH_CONN;
    netStringToIP("192.168.10.40", &interface.address);
    netStringToIP("255.255.255.0", &interface.netmask);

    // Netmasks of the form 192.168.1.255 will fail!

    // Start timer up. This *must* be done or the TCP/IP stack may not
    // behave correctly.
    // Interrupt handler to process incoming packets runs at regular
    // intervals (in this case 50 times per second, which is every 20ms).
    // Note that the ethernet doesn't have to be started to run this timer.
    startTimer(50, netProcess, 2);
    ipset1();

    // Start ethernet interface
    network = ethernetStart(&interface, NET_USE_DHCP, "192.168.10.2", NULL);
    printf("MAC: %s\n", netGetMAC(MACString, network));  
    if (network == NULL)
    {
        // Error code: ethernet initialization failed somehow
        printf("Error: ethernet failed to initialize\n");
    }
    else
    {
        // Successful initialization
        char name[HOSTNAME_LENGTH];
        //longword address;
        //eth_address addr;

        printf("Ethernet initialization succeeded\n");
        printf("hostname: %s\n", netGetHostName());
        printf("domain: %s\n", netGetDomainName());
        printf("ip: %s\n", netIPToString(&network->ip_addr, name));

        printf("initializing httpd server\n");
        httpd_init();
        printf("looping\n");
        while(1); // Loop forever. Rabbit device should be pingable.
    }

}
