/*
 * Definitions for the rabbit 2000 layer of the lwip system.
 *
 * (C) 2002 Compendium Technologies, Inc.
 * (C) 2002 Softools, Inc.
 * All rights reserved.
 *
 * This software is the proprietary information of Compendium Technologies, Inc.
 * and Softools, Inc. Use is subject to license terms.
 */
#ifndef __SYS_ARCH_H__
#define __SYS_ARCH_H__

#include <Rabbit2000.h>

#define SYS_MBOX_NULL NULL
#define SYS_SEM_NULL NULL

#define MESSAGE_BOX_SIZE 30

typedef signed char *sys_sem_t;

/**
 * Defines a message box used to transfer data between threads.
 */
typedef struct {
    u8_t first;
    u8_t last;
    u8_t numMessages;
    void *msgs[MESSAGE_BOX_SIZE];
    sys_sem_t mail;
} sys_mbox;

typedef sys_mbox *sys_mbox_t;
typedef int sys_thread_t;

#endif /* __SYS_ARCH_H__ */
